//-----------------------------------------------------------------------------
// Project:   Code for 'Using TStream to save application data' session
//            UK BUG Midlands Meeting 25/10/2002
// Module:    Main form for component streaming example
// Compiler:  Delphi 5+
// Author:    Mark Warriner                         mark@cybermunch.com
// Copyright: New Transducer Ltd. UK
//-----------------------------------------------------------------------------
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Button_Color: TButton;
    ColorDialog1: TColorDialog;
    Button_Save: TButton;
    Button_Load: TButton;
    procedure Button_ColorClick(Sender: TObject);
    procedure Button_SaveClick(Sender: TObject);
    procedure Button_LoadClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button_ColorClick(Sender: TObject);
begin
  ColorDialog1.Color:= Panel1.Color;
  ColorDialog1.Execute;
  Panel1.Color:= ColorDialog1.Color;
end;

procedure TForm1.Button_SaveClick(Sender: TObject);
var
  FileStream: TFileStream;
begin
  FileStream:= TFileStream.Create('MyFile.myf', fmCreate);
  try
    FileStream.WriteComponent(Panel1);
  finally
    FileStream.Free;
  end;
end;

procedure TForm1.Button_LoadClick(Sender: TObject);
var
  FileStream: TFileStream;
  Reader: TReader;
begin
  FileStream:= TFileStream.Create('MyFile.myf', fmOpenRead);
  try
    FileStream.ReadComponent(Panel1);
  finally
    FileStream.Free;
  end;
end;

end.
