//-----------------------------------------------------------------------------
// Project:   Code for 'Using TStream to save application data' session
//            UK BUG Midlands Meeting 25/10/2002
// Module:    Example file to show adding versioning to streaming
// Compiler:  Delphi 5+
// Author:    Mark Warriner                         mark@cybermunch.com
// Copyright: New Transducer Ltd. UK
//-----------------------------------------------------------------------------
// Code to show how to incorporate versioning into streams
// Version is written at start and end of block for clarity
//
// Saved Fields
// FMyPoint: TPoint
// FCaption: String
// FP0, FP1: TPoint (only in version 2)
//
//-----------------------------------------------------------------------------
unit version;
//-----------------------------------------------------------------------------
procedure TMyClass.ReadFields(S: TStream);
var
  Version: Integer;
begin
  { Version 1 }
  S.Read(Version, 4);
  S.Read(FMyPoint, 4*2);
  S.Read(Version, 4);
  FCaption:= StreamReadString(S);
  S.Read(Version, 4);

  { Version 2 }
  if Version = 2 then begin
    S.Read(FP0, 2*4);
    S.Read(FP1, 2*4);
    S.Read(Version, 4);
  end;
end;
//-----------------------------------------------------------------------------
procedure TMyClass.WriteFields(S: TStream);
var
  Version: Integer;
begin
  { Version 1 data }
  Version:= 1;  S.Write(Version, 4);
  S.Write(FMyPoint, 4*2);
  Version:= 1;  S.Write(Version, 4);
  StreamWriteString(S, FCaption);

  { Version 2 data }
  Version:= 2;  S.Write(Version, 4);
  S.Write(FP0, 2*4);
  S.Write(FP1, 2*4);
  Version:= 2;  S.Write(Version, 4);
end;
//-----------------------------------------------------------------------------


end.
 